export declare interface PluralizeOptions {
  count?: number
  inclusive?: boolean
}
declare type Rule = [RegExp, string]
type StringOrRegExp = string | RegExp

interface PluralizeFunction {
  (word: string, options?: PluralizeOptions): string
  plural: (word: string) => string
  isPlural: (word: string) => boolean
  singular: (word: string) => string
  isSingular: (word: string) => boolean
  addPluralRule: (rule: StringOrRegExp, replacement: string) => void
  addSingularRule: (rule: StringOrRegExp, replacement: string) => void
  addUncountableRule: (word: string | RegExp) => void
  addIrregularRule: (single: string, plural: string) => void
}

const pluralRules: Rule[] = []
const singularRules: Rule[] = []
const uncountables: Record<string, boolean> = {}
const irregularPlurals: Record<string, string> = {}
const irregularSingles: Record<string, string> = {}
declare function sanitizeRule(rule: string | RegExp): RegExp;
declare function restoreCase(word: string, token: string): string;
declare function interpolate(str: string, ...args: any[]): string;
declare function replace(word: string, rule: Rule): string;
declare function sanitizeWord(token: string, word: string, rules: Rule[]): string;
declare function replaceWord(replaceMap: Record<string, string>, keepMap: Record<string, string>, rules: Rule[]): (word: string) => string;
declare function checkWord(replaceMap: Record<string, string>, keepMap: Record<string, string>, rules: Rule[]): (word: string) => boolean;

export default pluralize;